//-----------------------------------------------------------------------------
// mrhx`s UnInstalling Module: VERSION 1.2
//
// (C) 2006, Alexander G. Karpov a.k.a. mrhx.
//
// Visit author's web-site: http://mrhx.narod.ru/
//
// Released: October 24, 2006.
// rel 1.2 @ March 26, 2007.
//-----------------------------------------------------------------------------

#include <windows.h>
#include <shellapi.h>
#include "resource.h"

//-----------------------------------------------------------------------------
// LINK&COMPILE OPTIONS.
//-----------------------------------------------------------------------------

#pragma comment(linker,"/NODEFAULTLIB")
#pragma comment(linker,"/ENTRY:main")
#pragma comment(linker,"/FILEALIGN:512")

//-----------------------------------------------------------------------------
// DEFINES.
//-----------------------------------------------------------------------------

#define TITLE		" ..."
#define DATFILE		"uninst.dat"
#define BATFILE		"..\\uninst.bat"
#define BATFILE1	"uninst.bat"
#define VERSION		"1.2"

//-----------------------------------------------------------------------------
// READ A LINE FROM FILE.
//-----------------------------------------------------------------------------
void ReadLine(HANDLE hFile, char *Buf)
{
	DWORD d;
	int i = -1;
	do
	{
		Buf[++i] = '\n';
		ReadFile(hFile, Buf+i, 1, &d, NULL);
	}
	while (Buf[i] != '\n' && Buf[i] != '\r');
	Buf[i] = '\0';
}

//-----------------------------------------------------------------------------
// Wait while object exists.
//-----------------------------------------------------------------------------
void wait_for_obj(char *name)
{
	while (GetFileAttributes(name) != 0xFFFFFFFF);
}

//-----------------------------------------------------------------------------
// MAIN FUNCTION.
//-----------------------------------------------------------------------------

void main()
{
	char homedir [MAX_PATH];
	char line [2048];
	GetCurrentDirectory(MAX_PATH, homedir);
	HANDLE hFile = CreateFile(DATFILE, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL, "   '"DATFILE"'     .\n ,    .", TITLE, MB_OK|MB_ICONERROR|MB_TOPMOST);
	}
	else
	{
		DWORD tmp;
		char text [512], prog [256];
		ReadLine(hFile, prog);
		wsprintf(text, "    \"%s\"   .\n ,   ?", prog);
		if (IDYES == MessageBox(NULL, text, TITLE, MB_YESNO|MB_ICONQUESTION|MB_TOPMOST))
		{
			int num = 0;
			do
			{
				ReadLine(hFile, line);
				if (*line == '@') // change directory.
				{
					SetCurrentDirectory(line+1);
					num = 0;
				}
				else if (*line == '#') // remove a file.
				{
					if (DeleteFile(line+1)) wait_for_obj(line+1);
					num = 0;
				}
				else if (*line == '%') // remove a directory.
				{
					if (RemoveDirectory(line+1)) wait_for_obj(line+1);
					num = 0;
				}
				else ++num;
			}
			while (num < 10);
			CloseHandle(hFile);
			// Delete dat-file:
			DeleteFile("uninst.dat");
			// Delete uninstaller:
			GetModuleFileName(NULL, text, 512);
			hFile = CreateFile(BATFILE, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
			wsprintf(line, "@echo off\ncd \"%s\"\n:try\ndel \"%s\"\nif exist \"%s\" goto try\ncd ..\nrmdir /S /Q \"%s\"\ndel %s", homedir, text, text, homedir, BATFILE1);
			WriteFile(hFile, line, lstrlen(line), &tmp, NULL);
			CloseHandle(hFile);
			ShellExecute(NULL, NULL, BATFILE, NULL, NULL, SW_HIDE);
			// UnInstalled!
			wsprintf(text, " \"%s\"     .", prog);
			MessageBox(NULL, text, TITLE, MB_OK|MB_ICONINFORMATION|MB_TOPMOST);
		}
		else CloseHandle(hFile);
	}
	ExitProcess(0);
}

//-----------------------------------------------------------------------------
// END OF FILE.
//-----------------------------------------------------------------------------
